diff --git a/src/http/ngx_http.h b/src/http/ngx_http.h
--- a/src/http/ngx_http.h
+++ b/src/http/ngx_http.h
@@ -111,6 +111,7 @@
 
 #define NGX_HTTP_LAST   1
 #define NGX_HTTP_FLUSH  2
+#define NGX_HTTP_SYNC   3
 
 ngx_int_t ngx_http_send_special(ngx_http_request_t *r, ngx_uint_t flags);
 
diff --git a/src/http/ngx_http_request.c b/src/http/ngx_http_request.c
--- a/src/http/ngx_http_request.c
+++ b/src/http/ngx_http_request.c
@@ -2912,6 +2912,10 @@
         b->flush = 1;
     }
 
+    if (flags & NGX_HTTP_SYNC) {
+        b->sync = 1;
+    }
+
     out.buf = b;
     out.next = NULL;
 
